unit BarreIc;
// Dl 29/04/00 modif gestion des Timer

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, jpeg,CompCadreIma2, ImgList;

type
  TBarreIcones = class(TForm)
    Panel1: TPanel;
    FlecheG: TImage;
    FlecheD: TImage;
    TimerG: TTimer;
    TimerD: TTimer;
    CadreImage21: TCadreImage2;
    CadreImage22: TCadreImage2;
    CadreImage23: TCadreImage2;
    CadreImage24: TCadreImage2;
    BoutonPlanche: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure ImageClick(Sender: TObject);
    procedure FlecheGMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FlecheDMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FlecheGMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FlecheDMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TimeG(Sender:TObject);
    procedure TimeD(Sender:TObject);
    procedure DeplacementGauche;
    procedure DeplacementDroit;
    procedure FormCreate(Sender: TObject);
    procedure BoutonPlancheClick(Sender: TObject);

  private
    { Dclarations prives }
    FSelection:TStringList;  // liste des noms des taxons slectionns

    Images : array[0..3] of TCadreImage2;
    NbImages:integer;
    procedure SetSelection(Sel:TStringList);
    
  public
    { Dclarations publiques }
    Premiere : integer;                 // index de la premire image
    procedure AfficheEspece(N: integer);
    procedure AfficheIcones(Tout:Boolean);
    property Selection:TStringList read FSelection write SetSelection ;
  end;

var
  BarreIcones: TBarreIcones;

implementation
uses StructureDonnees,Donnees, PhylObs, PhylChoi, PhylComp, PhylPlch, PhylMain,math;

{$R *.DFM}

procedure TBarreIcones.FormCreate(Sender: TObject);
var
   i:integer;
begin
    TimerG.Interval:=100; // millisecondes
    TimerG.Enabled:=false;
    TimerD.Interval:=100;
    TimerD.Enabled:=false; 
    Images[0]:=CadreImage21;
    Images[1]:=CadreImage22;
    Images[2]:=CadreImage23;
    Images[3]:=CadreImage24;
    NbImages:=4;
    Premiere:=0;
    for i:=0 to NbImages-1 do
    with Images[i] do
    begin
       OnClick:=ImageClick;
       Tag:=i;    // l'index de Taxons commence  0
    end;
    FSelection:=TStringList.Create;
    If ModeEcran800 then
      begin
        FlecheG.Width:=17;
        FlecheD.Width:=17;
        BoutonPlanche.Width:=36;
        if FileExists('bmpPl800.bmp') then
          BoutonPlanche.Glyph.LoadFromFile('bmpPl800.bmp');
        BoutonPlanche.Left:=394;
        width:=430;
      end
    else
      begin
        FlecheG.Width:=29;
        FlecheD.Width:=29;
        BoutonPlanche.Width:=50;
        BoutonPlanche.Left:=418;
        width:=474;
      end;
end;

procedure TBarreIcones.FormShow(Sender: TObject);
begin
  if FormActivite=FormObs then Selection:=FormObs.Selection
  else if FormActivite=FormComp then Selection:=FormComp.Selection
  else if FormActivite=FormChoisir then Selection:=FormChoisir.Selection;

  AfficheIcones((FormActivite<>FormChoisir));

end;

procedure TBarreIcones.ImageClick(Sender: TObject);
var
  NumIm,NumEsp:integer;
  NomEsp:string;
  ind:integer;
begin
  NumIm:= TCadreImage2(Sender).Tag;
  if NumIm<Length(LaSousCollection.TaxonsActifs) then
    begin
      if LaSousCollection.TaxonsActifs[NumIm]<>Nil then
        begin
          NumEsp:=LaSousCollection.NumTaxon(LaSousCollection.TaxonsActifs[NumIm]);
          if NumEsp>-1 then
            begin
              AfficheEspece(NumEsp);

              NomEsp:= LaSousCollection.Taxons.GetNom(NumEsp);
              ind:= FSelection.IndexOf(NomEsp);
              if FormActivite=FormObs then AObserve:=True;
              if (ind = -1) then
                begin
                  FSelection.Add(NomEsp);
                  if ((FormActivite=FormComp)and (FSelection.Count > 4))
                      or ((FormActivite=FormObs)and (FSelection.Count > 1)) then
                    begin
                      FSelection.Delete(0);
                    end;
                end
              else
                FSelection.Delete(ind);
              AfficheIcones((FormActivite<>FormChoisir));
            end;
        end;
    end;
end;

procedure TBarreIcones.AfficheEspece(N:integer);
begin
  if (Parent.Name='FormObs') then
    FormObs.AfficheEspece(N)
  else if (Parent.Name='FormChoisir') then
    FormChoisir.AfficheEspece(N)
  else if (Parent.Name='FormComp') then
    FormComp.AfficheEspece(N);
end;

procedure TBarreIcones.FlecheGMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  DeplacementGauche;
  TimerG.Enabled:=true;
end;

procedure TBarreIcones.AfficheIcones(Tout:Boolean); 
// affiche les icones  partir de Premiere
var
  i,p:integer;
  NomTaxon,NomAffiche,TypeTax:string;
  LeTaxon:TTaxon;
begin
  LaSousCollection.CreeTaxonsActifs(Tout);
  NbImages:=min(4,Length(LaSousCollection.TaxonsActifs));
  For i:=0 to NbImages-1 do
    Images[i].Visible:=True;
  For i:=NbImages to 3 do
    Images[i].Visible:=False;
  if Premiere>Length(LaSousCollection.TaxonsActifs)-NbImages then Premiere:=Length(LaSousCollection.TaxonsActifs)-NbImages;
  if Premiere<0 then Premiere:=0;
  for i:=0 to NbImages-1 do
    with Images[i] do
      begin
        Tag:=Premiere+i;
        LeTaxon:=LaSousCollection.TaxonsActifs[Tag];
        NomTaxon:= LeTaxon.Nom;
        NomAffiche:=NomTaxon;
        Affiche(LaSousCollection.GetIconeTaxActif(Tag),NomAffiche);
        Selected:=(FSelection.IndexOf(NomTaxon) <> -1);
        images[i].Refresh;
{        p:=LaSousCollection.NumTaxon(LeTaxon);
        if p>-1 then
          begin
            Affiche(LaSousCollection.Taxons.GetIcone(p),NomAffiche);
            Selected:=(FSelection.IndexOf(NomTaxon) <> -1);
            images[i].Refresh;
          end;}
      end;
end;


procedure TBarreIcones.DeplacementGauche;

begin
  if (Premiere>0) then
  begin
     Premiere:=Premiere-1;
     AfficheIcones((FormActivite<>FormChoisir));
  end;
end;

procedure TBarreIcones.FlecheDMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  DeplacementDroit;
  TimerD.Enabled:=true;
end;

procedure TBarreIcones.DeplacementDroit;
Var
  nb:integer;
begin
  if (Premiere < Length(LaSousCollection.TaxonsActifs)-NbImages) then
  begin
    Premiere:=Premiere+1;
    AfficheIcones((FormActivite<>FormChoisir));
  end;
end;


procedure TBarreIcones.FlecheGMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  TimerG.Enabled:=false;
end;

procedure TBarreIcones.FlecheDMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  TimerD.Enabled:=false;
end;


procedure TBarreIcones.TimeG(Sender:TObject);
begin
   DeplacementGauche;
end;

procedure TBarreIcones.TimeD(Sender:TObject);
begin
   DeplacementDroit;
end;

procedure TBarreIcones.BoutonPlancheClick(Sender: TObject);
begin
   FormPlanche.Hide;
   FormPlanche.Show;
end;

procedure TBarreIcones.SetSelection(Sel: TStringList);
begin
   FSelection:=Sel;
   //invalidate;
   //if visible=true
   // then Hide;      // jfr modifie 15 octobre 2001
   // Show;
end;

end.
