unit ChxCPH;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Forms, Dialogs, Controls, StdCtrls, 
  Buttons, ExtCtrls, CompCadreIma2, RXCtrls, Menus, ComCtrls,StructureDonnees,Donnees;

type
  TDialogChxCPH = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    MainMenu1: TMainMenu;
    axons1: TMenuItem;
    Caracteres1: TMenuItem;
    CaracteresD: TMenuItem;
    toutcocher1: TMenuItem;
    Toutdecocher1: TMenuItem;
    Toutcocher2: TMenuItem;
    Toutdecocher2: TMenuItem;
    Toutcocher3: TMenuItem;
    Toutdecocher3: TMenuItem;
    PanelAvert: TPanel;
    Panel1: TPanel;
    Nom: TEdit;
    Label5: TLabel;
    PageControl1: TPageControl;
    TaxEtCarD: TTabSheet;
    Label3: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    CheckListeTaxons: TRxCheckListBox;
    CheckListeCar: TRxCheckListBox;
    CheckListeTypeCar: TRxCheckListBox;
    CadreImage21: TCadreImage2;
    CheckListeCarD: TRxCheckListBox;
    Config: TTabSheet;
    CommencerPar: TRadioGroup;
    GroupBox1: TGroupBox;
    ExcluO: TCheckBox;
    ExcluC: TCheckBox;
    ExcluR: TCheckBox;
    ExcluB: TCheckBox;
    ExcluG: TCheckBox;
    ExcluA: TCheckBox;
    Label6: TLabel;
    excluP: TCheckBox;
    ExcluT: TCheckBox;
    InactivArbre: TCheckBox;
    UtilClasser6: TCheckBox;
    FmodeCollege: TCheckBox;
    ExcluD: TCheckBox;
    procedure ListeTaxonsMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure OKBtnClick(Sender: TObject);
    procedure toutcocher1Click(Sender: TObject);
    procedure Toutdecocher1Click(Sender: TObject);
    procedure Toutcocher3Click(Sender: TObject);
    procedure Toutdecocher3Click(Sender: TObject);
    procedure Toutcocher2Click(Sender: TObject);
    procedure Toutdecocher2Click(Sender: TObject);
    procedure CheckListeTypeCarClickCheck(Sender: TObject);
    procedure CheckListeCarClickCheck(Sender: TObject);
    procedure CheckListeTaxonsClickCheck(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure UtilClasser6Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    ListeNombresParType:Array of integer;
    ListeParType:Array of TstringList; // Listes de caractres par type
    ListeSelections:Array of Array of Boolean; // Listes de slection par type
    nbtc:integer;// nombre de types de caractres
    NbTaxonsCoches,NbTypesCoches,NbCarDCoches:integer;
    NbCarCoches:Array of integer;
    SousCol:TsousCollection;
    Procedure initialise;
    Procedure AjusteCaracteres;
    procedure Verifie;
    procedure LibereStringList; // appeler si annulation ou aprs collecte des donnes si OK
    function ConfigureSousCol:boolean;
  end;

var
  DialogChxCPH: TDialogChxCPH;

implementation

{$R *.dfm}
uses PhylPlch,ListArray2;

procedure TDialogChxCPH.Initialise;
Var
  i,j,n,p:integer;
  Nom:string;
  LeCarD:TCaractD;
  UnTaxon:TTaxon;
begin
  CheckListeTaxons.Clear;
  For i:=0 to LaSousCollection.Taxons.NbTaxons-1 do
    begin
      UnTaxon:=TTaxon(LaSousCollection.Taxons[i]);
      if (UnTaxon<>Nil) and (Pos('U',UnTaxon.TypeTaxon)=0)  and (Pos('X',UnTaxon.TypeTaxon)=0) then
        begin
          Nom:=UnTaxon.Nom;
          p:=CheckListeTaxons.Items.Add(Nom);
          CheckListeTaxons.Checked[p]:=UnTaxon.Selected;
        end
      else if (UnTaxon<>Nil) then UnTaxon.Selected:=false;
    end;
  if CheckListeTaxons.Items.Count>0 then
    begin
      n:=LaSousCollection.Taxons.GetNumTaxon(CheckListeTaxons.Items[0]);
      CadreImage21.Affiche(LaSousCollection.Taxons.GetIcone(n),LaSousCollection.Taxons.GetNom(n));
    end;
  CheckListeTypeCar.Clear;
  For i:= 0 to LaSousCollection.Caracteres.TypeCaract.Count-1 do
    begin
      CheckListeTypeCar.Items.Add(LaSousCollection.Caracteres.TypeCaract[i]);
      CheckListeTypeCar.Checked[i]:=True;
    end;
  nbtc:=LaSousCollection.Caracteres.TypeCaract.Count;
  SetLength(ListeSelections,nbtc);
  SetLength(ListeParType,nbtc);
  For i:=0 to nbtc-1 do
    begin
      if ListeParType[i]=nil then ListeParType[i]:=TStrinGList.Create;
      LaSousCollection.Caracteres.GetListeCar(i,ListeParType[i]);
      SetLength(ListeSelections[i],ListeParType[i].Count);
      For j:=0 to Length(ListeSelections[i])-1 do
        ListeSelections[i,j]:=True;
    end;
  CheckListeCar.Clear;
  For i:= 0 to LaSousCollection.Caracteres.Noms.Count-1 do
    begin
      CheckListeCar.Items.Add(LaSousCollection.Caracteres.Noms[i]);
      CheckListeCar.Checked[i]:=True;
    end;
  CheckListeCarD.Clear;
  For i:= 0 to LaSousCollection.Caracteres.CarDs.NbCarD-1 do
    begin
      LeCarD:=LaSousCollection.CarD[i];
      if LeCarD<>Nil then
        begin
          n:=CheckListeCarD.Items.Add(LeCarD.Nom);
          CheckListeCarD.Checked[n]:=False;    // tous dslectionns au dpart
       end;
    end;                                    // le programme d'appel les slectionne en fonction de FormChoisir (tableau)
  NbTaxonsCoches:=0;
  NbCarDCoches:=0;
  NbTypesCoches:=0;
  SetLength(NbCarCoches,nbtc);
  For i:=0 to nbtc-1 do
    NbCarCoches[i]:=0;
  Verifie;
end;

Procedure TDialogChxCPH.AjusteCaracteres;
Var
  i,j,cpt:integer;
  StrL:TStringList;
  numtype,numero:integer;
begin
  CheckListeCar.Clear;
  cpt:=0;
  For i:=0 to nbtc-1 do
    if CheckListeTypeCar.Checked[i] then
      begin
        StrL:=ListeParType[i];
        CheckListeCar.Items.AddStrings(StrL);
        for j:=0 to StrL.Count-1 do
          begin
            LaSousCollection.Caracteres.GetTypeNum(StrL[j],numtype,numero);
            CheckListeCar.Checked[cpt]:=ListeSelections[i,numero];
            inc(cpt);
          end;
      end;
  Verifie;
end;

procedure TDialogChxCPH.ListeTaxonsMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Var
  n,nt:integer;
  PosItem:Tpoint;
begin
  PosItem.X:=X;
  PosItem.Y:=Y;
  n:=CheckListeTaxons.ItemAtPos(PosItem,true);
  if n>-1 then
    begin
      nt:=LaSousCollection.Taxons.GetNumTaxon(CheckListeTaxons.Items[n]);
      CadreImage21.Affiche(LaSousCollection.Taxons.GetIcone(nt),LaSousCollection.Taxons.GetNom(nt));
    end;
end;


procedure TDialogChxCPH.toutcocher1Click(Sender: TObject);
Var
  i:integer;
begin
  for i:=0 to CheckListeTaxons.Items.Count-1 do
    begin
      CheckListeTaxons.Checked[i]:=True;
    end;
  Verifie;
end;

procedure TDialogChxCPH.Toutdecocher1Click(Sender: TObject);
Var
  i:integer;
begin
  for i:=0 to CheckListeTaxons.Items.Count-1 do
    begin
      CheckListeTaxons.Checked[i]:=False;
    end;
  Verifie;
end;

procedure TDialogChxCPH.Toutcocher3Click(Sender: TObject);
Var
  i:integer;
begin
  for i:=0 to CheckListeCar.Items.Count-1 do
    begin
      CheckListeCar.Checked[i]:=True;
    end;
  Verifie;
end;

procedure TDialogChxCPH.Toutdecocher3Click(Sender: TObject);
Var
  i:integer;
begin
  for i:=0 to CheckListeCar.Items.Count-1 do
    begin
      CheckListeCar.Checked[i]:=False;
    end;
  Verifie;
end;

procedure TDialogChxCPH.Toutcocher2Click(Sender: TObject);
Var
  i:integer;
begin
  for i:=0 to CheckListeCarD.Items.Count-1 do
    begin
      CheckListeCarD.Checked[i]:=True;
    end;
  Verifie;
end;

procedure TDialogChxCPH.Toutdecocher2Click(Sender: TObject);
Var
  i:integer;
begin
  for i:=0 to CheckListeCarD.Items.Count-1 do
    begin
      CheckListeCarD.Checked[i]:=False;
    end;
  Verifie;
end;


procedure TDialogChxCPH.CheckListeTypeCarClickCheck(Sender: TObject);
begin
  AjusteCaracteres;
end;

procedure TDialogChxCPH.CheckListeCarClickCheck(Sender: TObject);
var
  i:integer;
  numtype,numero:integer;
begin
  for i:=0 to CheckListeCar.Items.Count-1 do
    begin
      LaSousCollection.Caracteres.GetTypeNum(CheckListeCar.Items[i],numtype,numero);
      ListeSelections[numtype,numero]:=CheckListeCar.Checked[i];
    end;
  Verifie;
end;
procedure TDialogChxCPH.Verifie;
var
  i,j:integer;
  //StrL:TStringList;
  MessAvert:string;
  lien:string;
begin
  NbTaxonsCoches:=0;
  MessAvert:='';
  PanelAvert.Caption:='';
  lien:='';
  For i:=0 to CheckListeTaxons.Items.Count-1 do
    if CheckListeTaxons.Checked[i] then inc(NbTaxonsCoches);
  if NbTaxonsCoches<4 then
    begin
      MessAvert:=MessAvert+' moins de 4 taxons slectionns';
      lien:=' ;'
    end;
  NbTypesCoches:=0;
  For i:=0 to CheckListeTypeCar.Items.Count-1 do
    if CheckListeTypeCar.Checked[i] then inc(NbTypesCoches);
  if NbTypesCoches<1 then
    begin
      MessAvert:=MessAvert+lien+' aucun type slectionn';
      lien:=' ;'
    end;
  NbCarDCoches:=0;
  For i:=0 to CheckListeCarD.Items.Count-1 do
    if CheckListeCarD.Checked[i] then inc(NbCarDCoches);
  if NbCardCoches<3 then
    begin
      MessAvert:=MessAvert+lien+' moins de 3 caractres slectionns';
      lien:=' ;'
    end;
  For i:=0 to nbtc-1 do
    begin
      NbCarCoches[i]:=0;
      if CheckListeTypeCar.Checked[i] then
        For j:=0 to Length(ListeSelections[i])-1 do
          begin
            if ListeSelections[i,j] then inc(NbCarCoches[i]);
          end;
    end;
  if MessAvert<>'' then PanelAvert.Caption:='Attention :'+MessAvert;
end;
procedure TDialogChxCPH.LibereStringList; // appeler si annulation ou aprs collecte des donnes si OK
var
  i:integer;
  StrL:TStringList;
begin
  for i:=0 to nbtc-1 do
    begin
      StrL:=ListeParType[i];
      if StrL<>nil then StrL.Free;
    end;
  SetLength(ListeNombresParType,0);
  SetLength(ListeParType,0);
  SetLength(ListeSelections,0);
  nbtc:=0;
end;

procedure TDialogChxCPH.OKBtnClick(Sender: TObject); //  revoir
{Var
  nbTaxonsSelect,nbTypeSelect,nbCarSelect,nbCarDSelect:integer;}
begin
  Verifie;
  if PanelAvert.Caption='' then
    begin
      // vrifier qu'il n'y a pas de type sans caractre
      ModalResult:=mrOK;
    end
  else
    begin
      MessageDlg('Pas assez de taxons ou de caractres slectionns',mtError,[mbOK],0); //
      ModalResult:=mrNone;
    end;
end;

procedure TDialogChxCPH.CheckListeTaxonsClickCheck(Sender: TObject);
begin
  Verifie;
end;

procedure TDialogChxCPH.CancelBtnClick(Sender: TObject);
begin
  LibereStringList;
  ModalResult:=mrCancel;
end;

procedure TDialogChxCPH.UtilClasser6Click(Sender: TObject);
begin
  if UtilClasser6.Checked then InactivArbre.Checked:=True;
end;

function TDialogChxCPH.ConfigureSousCol:boolean;
Var
  i,n:integer;
  NomFicTab:string;
  UnTaxon:TTaxon;
begin
  Result:=True;
  // paramtres gnraux
  SousCol.ArbreExclu:=InactivArbre.Checked;
  SousCol.ClasserMode6:=UtilClasser6.Checked;
  SousCol.FModeCollege:=FmodeCollege.Checked;
  Case CommencerPar.ItemIndex of
    0:SousCol.CommencerPar:='O'; //Observer
    1:SousCol.CommencerPar:='C'; //Comparer
    2:SousCol.CommencerPar:='R'; //Construire
    3:SousCol.CommencerPar:='T'; //Construire  Tableau de rfrence charg
    4:SousCol.CommencerPar:='D'; //Coder
    5:SousCol.CommencerPar:='B'; //Classer
    6:SousCol.CommencerPar:='G'; //Grouper
    7:SousCol.CommencerPar:='A'; //Arbre
    8:SousCol.CommencerPar:=''; //Rien
  end;
  Souscol.Exclusions:='';
  if ExcluO.Checked and ExcluC.Checked and ExcluR.Checked and ExcluT.Checked and ExcluB.Checked and ExcluG.Checked
  and ExcluA.Checked then
    begin
      MessageDlg('Si tout est exclu, il n''y a plus rien  faire !',MtError,[mbOK],0);
      exit;
    end;
  if ExcluO.Checked then Souscol.Exclusions:=Souscol.Exclusions+'O';
  if ExcluC.Checked then Souscol.Exclusions:=Souscol.Exclusions+'C';
  if ExcluR.Checked then Souscol.Exclusions:=Souscol.Exclusions+'R';
  if ExcluT.Checked then Souscol.Exclusions:=Souscol.Exclusions+'T';
  if ExcluB.Checked then Souscol.Exclusions:=Souscol.Exclusions+'B';
  if ExcluG.Checked then Souscol.Exclusions:=Souscol.Exclusions+'G';
  if ExcluA.Checked then Souscol.Exclusions:=Souscol.Exclusions+'A';
  if ExcluP.Checked then Souscol.Exclusions:=Souscol.Exclusions+'P';
  if ExcluD.Checked then Souscol.Exclusions:=Souscol.Exclusions+'D';//exclusion de Dater
  //Ajustement des taxons et des caractres
  SousCol.Nom:=Nom.Text; //  complter
  SousCol.DossierCollection:=LaSousCollection.DossierCollection;
  SousCol.Caracteres:=LaSousCollection.Caracteres;
  SousCol.Caracteres.SelecTout;
  // Slection des caractres D cochs
  For i:=0 to CheckListeCarD.Items.Count-1 do
    SousCol.CarD[i].Selected:=CheckListeCarD.Checked[i];
  // Taxons
  SousCol.Taxons:=TTaxons.Create;
  SousCol.Taxons.Copie(LaSousCollection.Taxons,True);
  SousCol.Taxons.FCaracteres:=SousCol.Caracteres;
  // slection des taxons conservs
  For i:=0 to SousCol.Taxons.NbTaxons-1 do
    begin
      UnTaxon:=TTaxon(SousCol.Taxons.Items[i]);
      if UnTaxon<>Nil Then
        begin
          n:=CheckListeTaxons.Items.IndexOf(UnTaxon.Nom);
          if n>-1 then UnTaxon.Selected:=CheckListeTaxons.Checked[n]
          else UnTaxon.Selected:=False;
        end;
    end;

  if LaSousCollection.TabRef=nil then  // recharger le tableau de rfrence si ce n'est dj fait;
    begin
      NomFicTab:=CheminTableaux+SeriesImages[NumSerImActive]+ExtFicMat;
      if Not FileExists(NomFicTab) then
        NomFicTab:=CheminsCollections[NumColActive]+'\'+RepCaractIm+'\'+SeriesImages[NumSerImActive]+ExtFicMat;
      if FileExists(NomFicTab) then
        LaSousCollection.LitTabref(NomFicTab)
      else
        begin
          MessageDlg('Le tableau de rfrence est introuvable',mtError,[mbOK],0);
          Result:=False;
          exit;
        end;
    end;

  //transmettre le tableau de rfrence;
  if SousCol.TabRef=Nil then SousCol.TabRef:=TStrListArray.createListArray;
  //SousCol.TabRef.Assign(LaSousCollection.TabRef);
end;
end.
