unit PhylPlch;

// 22/01/01 Modif CreeIcones pour position boutonOK si dernire ligne pleine
// 16/11/99 CreeIcones remplace AfficheIcones et devient publique (appele ds
//            PhylMain
//          Modif FormClose

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,StdCtrls,ExtCtrls,
   Forms, Dialogs,  jpeg, Buttons;

type
  TFormPlanche = class(TForm)
    BoutonOK: TButton;
    Memo: TMemo;
    PanelAvert: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure Clique(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BoutonOKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MemoClick(Sender: TObject);
  private
    { Dclarations prives }
    ListeIcones:TList;
    FSelection:TStringList;         // liste des noms des espces slectionnes
    //prefois:boolean;
    EcartY:integer; // Ecart vertical entre les icones
    EcartX :integer; // Ecart horizontal entre les icones
    Largeur_ic:integer;
    procedure AfficheSelection;
    procedure SourisDown(Sender: TObject; Button: TMouseButton;
                                      Shift: TShiftState; X, Y: Integer);
  public
    { Dclarations publiques }
     procedure CreeIcones(Tout:Boolean);
     property Selection:TStringList read FSelection write FSelection;
     Procedure RAZIcones;
     procedure AffichePrecisions(X,Y:integer;NomTaxon:string);
  end;
var
  FormPlanche: TFormPlanche;
  PosX, PosY: Word;

implementation

uses StructureDonnees,Donnees, PhylObs, PhylMain, CompCadreIma2, BarreIc, PhylChoi, PhylComp;

{$R *.DFM}

procedure TFormPlanche.FormCreate(Sender: TObject);
begin
  //prefois:=True;
  FormPrinc.Fille(Self);
  PosX:=EcartX; // position de l'icone du 1er taxon
  PosY:=EcartY;
  ListeIcones:=TList.Create;
  FSelection:=TStringList.Create;
  BoutonOK.Visible:=false;
  EcartX:= 1; // Ecart horizontal entre les icones
  Largeur_ic:=89;
  if width>810 then EcartY:= 10 else EcartY:= 1;
  Memo.Cursor:=crInverse;
end;

procedure TFormPlanche.CreeIcones(Tout:Boolean);
var
  Icone:TCadreImage2;
  i:integer;
  NomTaxon,NomAffiche:string;
  LeTaxon:TTaxon;
  LargeurDispo:integer;
begin
  LargeurDispo:=ClientWidth-BoutonOK.Width-2-2*EcartX;
  for i:=0 to LaSousCollection.Taxons.NbTaxons - 1 do
    begin
      LeTaxon:=TTaxon(LaSousCollection.Taxons[i]);
      if (LeTaxon<>Nil) and LeTaxon.Enabled and (pos('X',LeTaxon.TypeTaxon)=0)
            and(Tout or (pos('U',LeTaxon.TypeTaxon)=0))then
        begin
          Icone:=TCadreImage2.Create(Self);// ici self est quivalent  FormPlanche
          ListeIcones.Add(Icone);
          With Icone do
            begin
              Parent:=Self;  //  la fiche
              BevelWidth:=2;
              OnClick:=Clique; // vnement on Click dclenchera la procdure Clique
              OnMouseDown:=SourisDown;
              Cursor:=crInverse;
              Height:=65; //
              Width:=Largeur_ic;  // 320/4
              Font.Name:='Arial';
              Font.Size:=7;
              NomTaxon:=LaSousCollection.Taxons.GetNom(i);
              NomAffiche:=NomTaxon;
              TypeTax:=TTaxon(LaSousCollection.Taxons[i]).TypeTaxon;
              {if LaSousCollection.EstFossile(i) then
                begin
                  NomAffiche:=NomTaxon+' F '+LaSousCollection.AgeStr(i);
                end;}
              //else if LaSousCollection.EstExterne(i) then Font.color:=clBlue;
              //else Font.color:=clBlack;

              Affiche(LaSousCollection.Taxons.GetIcone(i),NomAffiche);
              Tag:=i;

              Left:=PosX; // Position en X de l'icone
              Top:=Posy;  // Position en Y de l'icone
              PosX:=PosX+Width+EcartX; // pour que la prochaine icone cre se mette plus  gauche
              //If (PosX>Self.Width-Width) and (i <> LaSousCollection.Taxons.NbTaxons - 1) then
              If (PosX>LargeurDispo-Width) and (i <> LaSousCollection.Taxons.NbTaxons - 1) then
              // Si on dpasse la longueur de la fiche
              // on positionne la prochaine icone plus bas
                begin
                  PosY:=PosY+Height+EcartY;
                  if PosY>Self.Height then Self.Height:=PosY+Height;
                  PosX:=EcartX;
                end;
            end; // with
        end  //if
    end; // for
  BoutonOK.Top:=PosY;
  BoutonOK.Left:=Self.Width-BoutonOK.Width-2;
  //BoutonOK.Height:=65;
  FormPrinc.RetourCreeIcones;
end;
procedure TFormPlanche.SourisDown(Sender: TObject; Button: TMouseButton;
                                      Shift: TShiftState; X, Y: Integer);
Var
  n:integer;
  texte:string;
  Cadre:TCadreImage2;
begin
  if Button=mbRight then
    begin
      Cadre:=TCadreImage2(Sender);
      //Cadre.Cursor:=crInverse;
      n:=Cadre.Tag;
      Memo.Clear;
      texte:=LaSousCollection.Taxons.GetNom(n);
      Memo.Lines.add(texte);
      //Memo.Width:=Memo
      if LaSousCollection.EstFossile(n) then
        begin
          Memo.Lines.add('fossile');
          Memo.Lines.add(LaSousCollection.AgesStr(n));
        end;
      if LaSousCollection.EstExterne(n) then
        begin
          Memo.Lines.add('extragroupe');
        end;
      Memo.Top:=Y+Cadre.Top;;
      Memo.Left:=X+Cadre.Left;
      Memo.Visible:=True;
      Memo.BringToFront;
    end;
end;
procedure TFormPlanche.Clique (Sender:TObject);
begin
  PanelAvert.Visible:=False;
  with TCadreImage2(Sender) do
    begin
      // mise  jour de la Selection
      if FormActivite=FormObs then
        begin
          FSelection.Clear;
          FSelection.Add(LaSousCollection.Taxons.GetNom(Tag));
          LaSousCollection.Taxons.RAZSelected;
          TTaxon(LaSousCollection.Taxons.Items[Tag]).Selected:=True;
          AObserve:=True;
        end
      else
        begin
          Selected:=not Selected;
          if Selected then
            if (FormActivite=FormComp) and (FSelection.Count >= 4) then
              Selected:=false
            else
               FSelection.Add(LaSousCollection.Taxons.GetNom(Tag))
          else
            FSelection.Delete(FSelection.IndexOf(LaSousCollection.Taxons.GetNom(Tag)));
          TTaxon(LaSousCollection.Taxons.Items[Tag]).Selected:=Selected;
        end;
       // lancement ventuel de l'activit Observer (pour les autres voir BoutonOK)
      if FormActivite=FormObs then
        begin
          BarreIcones.Premiere:= Tag;
          if (BarreIcones.Premiere > LaSousCollection.Taxons.NbTaxons-4) then
            BarreIcones.Premiere := LaSousCollection.Taxons.NbTaxons-4;
          Self.Hide;

          if (FormObs.ImageCar.tag=-1) then             // jfr modifie 16 octobre 2001
            FormObs.ImageCar.Hide;                // pour cacher les fenetres d'image et de texte
          if (FormObs.texteCar.Visible=false) then
            FormObs.invalidate;

          FormObs.Show;
          FormObs.AfficheEspece(Tag);

          FormObs.NomEsp.repaint;   // jfr modifie 16 octobre 2001

          BarreIcones.Selection:=Selection;
          BarreIcones.AfficheIcones(true);  // jfr modifie 16 octobre 2001
        end;
    end;
end;
procedure TFormPlanche.AffichePrecisions(X,Y:integer;NomTaxon:string);
begin

end;

procedure TFormPlanche.BoutonOKClick(Sender: TObject);
begin
   if FormActivite=FormChoisir then
     FormChoisir.MajEspeces(Selection)
   else if FormActivite=FormComp then
     FormComp.MajEspeces(Selection);
//   ModalResult:=mrOK;
   BarreIcones.Selection:=Selection;
   BarreIcones.AfficheIcones((FormActivite<>FormChoisir));    // jfr modifie 16 octobre 2001    rajoute
   Self.Hide;
end;

procedure TFormPlanche.FormClose(Sender: TObject;
  var Action: TCloseAction);
{var
  i:integer;}
begin
{  PosX:=EcartX; // rinitialisation de la position de l'icone du 1er taxon
  PosY:=EcartY;
  if Assigned(ListeIcones) then
    for i:=0 to ListeIcones.Count-1 do TCadreImage2(ListeIcones.Items[i]).Free;
  ListeIcones.Clear;
  FSelection.Clear;} 
end;
Procedure TFormPlanche.RAZIcones;
var
  i:integer;
begin
  PosX:=EcartX; // rinitialisation de la position de l'icone du 1er taxon
  PosY:=EcartY;
  if Assigned(ListeIcones) then
    for i:=0 to ListeIcones.Count-1 do TCadreImage2(ListeIcones.Items[i]).Free;
  ListeIcones.Clear;
  if assigned(FSelection) then FSelection.Clear;
end;

procedure TFormPlanche.AfficheSelection;
var
   i: integer;
   NomTaxon: string;
begin
   if (FSelection.Count = 0) then
      for i:=0 to ListeIcones.Count-1 do
        TCadreImage2(ListeIcones[i]).Selected:=false
   else
      for i:=0 to ListeIcones.Count-1 do
      begin
         NomTaxon:=LaSousCollection.Taxons.GetNom(TCadreImage2(ListeIcones[i]).Tag);
         if (FSelection.IndexOf(NomTaxon) <> -1) then
           TCadreImage2(ListeIcones[i]).Selected:=true
         else
            TCadreImage2(ListeIcones[i]).Selected:=false;
      end;
end;

procedure TFormPlanche.FormShow(Sender: TObject);
begin
 if FormActivite<>FormObs then
   BoutonOK.Visible:=true else BoutonOK.Visible:=false;

 if FormActivite=FormChoisir then
      Selection:=FormChoisir.Selection
   else if FormActivite=FormComp then
         Selection:=FormComp.Selection
    else if FormActivite=FormObs then
         Selection:=FormObs.Selection;
 AfficheSelection;
end;

procedure TFormPlanche.FormDestroy(Sender: TObject);
begin
 RAZIcones;
end;

procedure TFormPlanche.MemoClick(Sender: TObject);
begin
  Memo.Visible:=false;
end;

end.
